Package net.sf.saxon.lib

## Interface TraceListener

- All Superinterfaces:
    `java.util.EventListener`
  All Known Implementing Classes:
    `AbstractTraceListener`, `ContentHandlerProxy.ContentHandlerProxyTraceListener`, `ModeTraceListener`, `TimingTraceListener`, `TraceEventMulticaster`, `XQueryTraceListener`, `XSLTTraceListener`

      public interface TraceListener
      extends java.util.EventListener

  This interface defines methods that are called by Saxon during the execution of a stylesheet, if tracing is switched on. Tracing can be switched on by nominating an implementation of this class using the TRACE_LISTENER feature of the TransformerFactory, or using the addTraceListener() method of the Controller, which is Saxon's implementation of tyhe JAXP javax.xml.transform.Transformer interface.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Method called at the end of execution, that is, when the run-time execution ends
    `void` | `endCurrentItem​(Item currentItem)` | Method that is called when an instruction has finished processing a new current item and is ready to select a new current item or revert to the previous current item.
    `default void` | `endRuleSearch​(java.lang.Object rule, Mode mode, Item item)` | Method called when a rule search has completed.
    `default void` | `enter​(Traceable instruction, java.util.Map<java.lang.String,​java.lang.Object> properties, XPathContext context)` | Method that is called when an instruction in the stylesheet gets processed.
    `default void` | `leave​(Traceable instruction)` | Method that is called after processing an instruction of the stylesheet, that is, after any child instructions have been processed.
    `void` | `open​(Controller controller)` | Method called at the start of execution, that is, when the run-time transformation starts
    `void` | `setOutputDestination​(Logger stream)` | Method called to supply the destination for output
    `void` | `startCurrentItem​(Item currentItem)` | Method that is called by an instruction that changes the current item in the source document: that is, xsl:for-each, xsl:apply-templates, xsl:for-each-group.
    `default void` | `startRuleSearch()` | Method called when a search for a template rule is about to start

- - ### Method Detail

    - #### setOutputDestination

          void setOutputDestination​(Logger stream)

      Method called to supply the destination for output
      Parameters:
        `stream` - a Logger to which any output produced by the TraceListener should be written
      Since:
        8.0. Changed in 9.6 to accept a Logger.

    - #### open

          void open​(Controller controller)

      Method called at the start of execution, that is, when the run-time transformation starts
      Parameters:
        `controller` - identifies the transformation controller, and provides the listener with access to context and configuration information

    - #### close

          void close()

      Method called at the end of execution, that is, when the run-time execution ends

    - #### enter

          default void enter​(Traceable instruction,
                             java.util.Map<java.lang.String,​java.lang.Object> properties,
                             XPathContext context)

      Method that is called when an instruction in the stylesheet gets processed. Default implementation does nothing.
      Parameters:
        `instruction` - gives information about the instruction being executed, and about the context in which it is executed. This object is mutable, so if information from the InstructionInfo is to be retained, it must be copied.
        `properties` - extra information about the instruction to be included in the trace
        `context` - the XPath evaluation context

    - #### leave

          default void leave​(Traceable instruction)

      Method that is called after processing an instruction of the stylesheet, that is, after any child instructions have been processed. Default implementation does nothing.
      Parameters:
        `instruction` - gives the same information that was supplied to the enter method, though it is not necessarily the same object. Note that the line number of the instruction is that of the start tag in the source stylesheet, not the line number of the end tag.

    - #### startCurrentItem

          void startCurrentItem​(Item currentItem)

      Method that is called by an instruction that changes the current item in the source document: that is, xsl:for-each, xsl:apply-templates, xsl:for-each-group. The method is called after the enter method for the relevant instruction, and is called once for each item processed.
      Parameters:
        `currentItem` - the new current item. Item objects are not mutable; it is safe to retain a reference to the Item for later use.

    - #### endCurrentItem

          void endCurrentItem​(Item currentItem)

      Method that is called when an instruction has finished processing a new current item and is ready to select a new current item or revert to the previous current item. The method will be called before the leave() method for the instruction that made this item current.
      Parameters:
        `currentItem` - the item that was current, whose processing is now complete. This will represent the same underlying item as the corresponding startCurrentItem() call, though it will not necessarily be the same actual object.

    - #### startRuleSearch

          default void startRuleSearch()

      Method called when a search for a template rule is about to start

    - #### endRuleSearch

          default void endRuleSearch​(java.lang.Object rule,
                                     Mode mode,
                                     Item item)

      Method called when a rule search has completed.
      Parameters:
        `rule` - the rule (or possible built-in ruleset) that has been selected
        `mode` - the mode in operation
        `item` - the item that was checked against